// Generated by CoffeeScript 1.7.1
var Keys, _;

_ = require('underscore');

Keys = (function() {
  function Keys(keyFor) {
    if (keyFor == null) {
      keyFor = function(x) {
        return x;
      };
    }
    this.keyForValue = keyFor;
    this.keyToValue = {};
  }

  Keys.prototype.keyPresent = function(key) {
    return this.keyToValue[key] !== void 0;
  };

  Keys.prototype.valuePresent = function(o) {
    return this.keyToValue[this.keyForValue(o)] !== void 0;
  };

  Keys.prototype.add = function(o) {
    var key;
    if (!o) {
      return null;
    }
    key = this.keyForValue(o);
    this.keyToValue[key] = o;
    return key;
  };

  Keys.prototype.remove = function(o) {
    if (!o) {
      return null;
    }
    return delete this.keyToValue[this.keyForValue(o)];
  };

  Keys.prototype._key = function(value) {
    return this.add(value);
  };

  Keys.prototype._value = function(key) {
    if (!key) {
      return null;
    }
    return this.keyToValue[key];
  };

  Keys.prototype.key = function(values) {
    if (Array.isArray(values)) {
      return _.map(values, (function(_this) {
        return function(x) {
          return _this._key(x);
        };
      })(this));
    } else {
      return this._key(values);
    }
  };

  Keys.prototype.value = function(keys) {
    if (Array.isArray(keys)) {
      return _.map(keys, (function(_this) {
        return function(x) {
          return _this._value(x);
        };
      })(this));
    } else {
      return this._value(keys);
    }
  };

  Keys.prototype.exportKeyFunction = function() {
    return (function(_this) {
      return function(v) {
        return _this.key(v);
      };
    })(this);
  };

  Keys.prototype.exportValueFunction = function() {
    return (function(_this) {
      return function(k) {
        return _this.value(k);
      };
    })(this);
  };

  return Keys;

})();

exports.Keys = Keys;
